//-----------------------------------------------------------------------------
// Credits
//-----------------------------------------------------------------------------
// Made by Lacry


//-----------------------------------------------------------------------------
// Variables
//-----------------------------------------------------------------------------

red_players <- []
red_players_left <- 0

is_round_active <- false

lastman_red_check <- false

max_players <- MaxClients().tointeger()


//-----------------------------------------------------------------------------
// Functions
//-----------------------------------------------------------------------------

ClearGameEventCallbacks()

// Counts the players during the match
function count_players()
{
	if (!is_round_active) return -1
	
	lastman_red_logic()
	
	if (red_players_left == 0)
	{
		winner_logic()
	}
	
	NetProps.SetPropInt(self, "m_nRedScore", red_players_left)
	
	return -1
}


// Logic when the round starts
function round_start()
{
	for (local i = 1; i <= max_players; i++)
	{
		local player = PlayerInstanceFromIndex(i)
		if (player == null || !is_player_valid(player)) continue
		
		if (player.GetTeam() == 2)
		{
			red_players.append(player)
		}
	}
	
	is_round_active = true
	
	return
}

function is_player_valid(player)
{
	return ((player.GetTeam() & 2))
}


// RED Player Counter
function add_red()
{
	red_players_left++
}

function rest_red()
{
	red_players_left--
}


// Last man standing check (RED)
function lastman_red_set()
{
	lastman_red_check = false
}


// Last man standing (RED)
function lastman_red_logic()
{
	if (red_players_left == 1 && lastman_red_check == false)
	{
		DoEntFire("announcer_lastman_red", "PickRandomShuffle", "", 0, null, null)
		lastman_red_check = true
	}
	
	return
}


// Logic when the round ends
function round_end()
{
	is_round_active = false
}


// Sets Winner/Loser (By killing)
function winner_logic()
{
	if (is_round_active == true)
	{
		DoEntFire("game_win_blue", "RoundWin", "", 0, null, null);
	}
	
	return
}


__CollectGameEventCallbacks(this)